/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2008-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 * ^[QbgˑW[
 */
#include "kernel_impl.h"
#include <sil.h>

#include "fm3_mb9bxxx.h"
#include "target_serial.h"

/*
 *  ^[Qbgˑ̏
 */
void
target_initialize(void){

	static uint32_t u32IoRegisterRead;

	/*
	 *  n[hEFAEEIb`hOE^C}̒~
	 */
	sil_wrw_mem((uint32_t*)FM3_HWWDT_WDG_LCK, 0x1ACCE551);
	sil_wrw_mem((uint32_t*)FM3_HWWDT_WDG_LCK, 0xE5331AAE);
	sil_wrb_mem((uint8_t*)FM3_HWWDT_WDG_CTL, 0);

	/*
	 *  NbN̐ݒ
	 */
	sil_wrb_mem((uint8_t*)FM3_CRG_BSC_PSR, 0);
	sil_wrb_mem((uint8_t*)FM3_CRG_APBC0_PSR, 0);
	sil_wrb_mem((uint8_t*)FM3_CRG_APBC1_PSR, APBC1_PSR_APBC1EN | 1);
	sil_wrb_mem((uint8_t*)FM3_CRG_APBC2_PSR, APBC2_PSR_APBC2EN | 1);
	sil_wrb_mem((uint8_t*)FM3_CRG_SWC_PSR, SWC_PSR_TESTB | 3);
	sil_wrb_mem((uint8_t*)FM3_CRG_TTC_PSR, 0);

	sil_wrb_mem((uint8_t*)FM3_CRG_CSW_TMR, (5 << 4) | 0x0C);

	sil_wrb_mem((uint8_t*)FM3_CRG_SCM_CTL, sil_reb_mem((uint8_t*)FM3_CRG_SCM_CTL) | SCM_CTL_MOSCE);
	while (!(sil_reb_mem((uint8_t*)FM3_CRG_SCM_STR) & SCM_CTL_MOSCE));

	sil_wrb_mem((uint8_t*)FM3_CRG_PSW_TMR, 0);
	sil_wrb_mem((uint8_t*)FM3_CRG_PLL_CTL1, ((1-1)<<4) | ((2-1)<<0));
	sil_wrb_mem((uint8_t*)FM3_CRG_PLL_CTL2, 36-1);

	sil_wrb_mem((uint8_t*)FM3_CRG_SCM_CTL, sil_reb_mem((uint8_t*)FM3_CRG_SCM_CTL) | SCM_CTL_PLLE);
	while (!(sil_reb_mem((uint8_t*)FM3_CRG_SCM_STR) & SCM_CTL_PLLE));

	sil_wrb_mem((uint8_t*)FM3_CRG_SCM_CTL, sil_reb_mem((uint8_t*)FM3_CRG_SCM_CTL) | (2 << 5));

	do
	{
		u32IoRegisterRead = (sil_reb_mem((uint8_t*)FM3_CRG_SCM_CTL) & 0xE0); 
	}while ((sil_reb_mem((uint8_t*)FM3_CRG_SCM_STR) & 0xE0) != u32IoRegisterRead);

	/*
	 *  CRg~O̐ݒ
	 */
	if( 0x000003FF != (sil_rew_mem((uint32_t*)FM3_FLASH_IF_CRTRMM) & 0x000003FF) )
	{
		sil_wrw_mem((uint32_t*)FM3_CRTRIM_MCR_RLR, 0x1ACCE554);
		sil_wrw_mem((uint32_t*)FM3_CRTRIM_MCR_FTRM, sil_rew_mem((uint32_t*)FM3_FLASH_IF_CRTRMM));
		sil_wrw_mem((uint32_t*)FM3_CRTRIM_MCR_RLR, 0x00000000);
	}

	/*
	 * RAˑ̏
	 */
	core_initialize();

	/*
	 *  oi[o͗p̃VA
	 */
	target_uart_init(SIO_PORTID);
} 


/*
 *  ^[Qbgˑ̏I
 */
void
target_exit(void)
{
	/*
	 *  RAˑ̏I
	 */
	core_terminate();

	/*
	 *  Jˑ̏I
	 */
	while(1);
}


/*
 *  VXeO̒჌xo͂̂߂̕o
 */
void
target_fput_log(char c)
{
	if (c == '\n') {
		sio_pol_snd_chr('\r', SIO_PORTID);
	}
	sio_pol_snd_chr(c, SIO_PORTID);
}
